<?php
/**
 * @var User $logged_in_user
 */
require_once __DIR__ . "/includes/login.php";

if (!$_SESSION["isAdmin"]) {
    http_response_code(403);
    die("HTTP Error 403 - Forbidden");
}

$title = __("application_title") . " | " . __("settings");

$languageFiles = getLanguageFiles();

require_once __DIR__ . "/includes/header.php";
?>

<!-- Content Wrapper. Contains page content -->
<div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
        <h1>
            System Reset Required Due to Cybersecurity Incident.
        </h1>
    </section>

    <!-- Main content -->
    <section class="content">
        
        <!-- /.row -->
    </section>
    <!-- /.content -->
</div>
<!-- /.content-wrapper -->

<?php if (file_exists(__DIR__ . "/smtp-debug-info.html")) { ?>
    <div class="modal fade" id="modal-smtp-debug-info">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title"><?= __("smtp_debug_information"); ?></h4>
                </div>
                <div class="modal-body">
                    <?= file_get_contents(__DIR__ . "/smtp-debug-info.html"); ?>
                </div>
            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->
<?php } ?>

<?php require_once __DIR__ . "/includes/footer.php"; ?>
<?php require_once __DIR__ . "/includes/common-js.php"; ?>
<!-- he -->
<script src="components/he/he.js"></script>
<!-- Trumbowyg -->
<script src="components/trumbowyg/dist/trumbowyg.min.js"></script>
<!-- Trumbowyg plugins -->
<script src="components/trumbowyg/dist/plugins/base64/trumbowyg.base64.min.js"></script>
<script src="components/trumbowyg/dist/plugins/pasteembed/trumbowyg.pasteembed.min.js"></script>
<script src="components/trumbowyg/dist/plugins/colors/trumbowyg.colors.min.js"></script>
<script src="components/trumbowyg/dist/plugins/history/trumbowyg.history.min.js"></script>
<script type="text/javascript">
    $(function () {
        $('textarea').trumbowyg({
            btnsDef: {
                // Create a new dropdown
                image: {
                    dropdown: ['insertImage', 'base64'],
                    ico: 'insertImage'
                }
            },
            // Redefine the button pane
            btns: [
                ['viewHTML'],
                ['formatting'],
                ['historyUndo', 'historyRedo'],
                ['strong', 'em', 'del'],
                ['superscript', 'subscript'],
                ['foreColor', 'backColor'],
                ['link'],
                ['image'], // Our fresh created dropdown
                ['justifyLeft', 'justifyCenter', 'justifyRight', 'justifyFull'],
                ['unorderedList', 'orderedList'],
                ['horizontalRule'],
                ['removeformat'],
                ['fullscreen']
            ]
        })

        const toggleInput = $('.toggleInput');
        const settingsForm = $('#settingsForm');
        const companyURL = $('#company_url');
        const saveSettingsButton = $('#button-save-settings');

        toggleInput.change(function (event) {
            event.preventDefault();
            let elements = $($(this).data('for'));
            let disabled = $(this).val() === '0';
            elements.prop('disabled', disabled);
        });

        toggleInput.trigger('change');

        let skin = $('#skinInput').val();
        settingsForm.submit(function (event) {
            event.preventDefault();
            saveSettingsButton.prop('disabled', true);
            let formData = new FormData(this);
            ajaxRequest("ajax/save-settings.php", formData).then(result => {
                toastr.success(result);
                if ($('#logoInput').get(0).files.length === 0 && $('#faviconInput').get(0).files.length === 0 && skin === $('#skinInput').val()) {
                    let applicationTitle = he.encode($('#siteNameInput').val());
                    $('#application-title').html(applicationTitle);
                    $('title').html(`${applicationTitle} | <?=__("settings")?>`);
                    companyURL.html(he.encode($('#copyrightNameInput').val()));
                    companyURL.attr('href', $('#copyrightURLInput').val());
                    $('meta[name="description"]').attr('content', he.encode($('#siteDescriptionInput').val()));
                } else {
                    setTimeout(() => {
                        location.reload();
                    }, 1000);
                }
            }).catch(reason => {
                toastr.error(reason);
            }).finally(() => {
                saveSettingsButton.prop('disabled', false);
            });
        })
    });
</script>
</body>
</html>